/**************************************************/
/* This class is used to draw digits on a surface */
/**************************************************/

/*
This file is part of Tuxworld.

    Tuxworld is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Tuxworld is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Tuxworld.  If not, see <http://www.gnu.org/licenses/>.

Ce fichier fait partie de Tuxworld.

	Tuxworld est un logiciel libre ; vous pouvez le redistribuer ou le
	modifier suivant les termes de la GNU General Public License telle
	que publiée par la Free Software Foundation ; soit la version 3 de
	la licence, soit (à votre gré) toute version ultérieure.

	Tuxworld est distribué dans l'espoir qu'il sera utile, mais SANS
	AUCUNE GARANTIE ; pas même la garantie implicite de
	COMMERCIABILISABILITÉ ni d'ADÉQUATION à UN OBJECTIF PARTICULIER.
	Consultez la GNU General Public License pour plus de détails.

	Vous devez avoir reçu une copie de la GNU General Public License
	en même temps que Tuxworld ; si ce n'est pas le cas,
	consultez <http://www.gnu.org/licenses>.
*/

#ifndef DRAW_DIGITS
#define DRAW_DIGITS

#include <iostream>
#include "draw.h"
#include "SDL.h"
#include <SDL/SDL_image.h>
#include <SDL/SDL_opengl.h>

class CDraw_Digits : CDraw
{ 

   public :

      // construct from a file
      CDraw_Digits(const std::string& file, const SDL_Rect& coord, const float& coef_resol_);
      // show all numbers
      void show(const int& d, const float& deep);

   private :

      // image of a letter and offset position in the full image | coord : locate the number
      SDL_Rect src, coord;
      // show an unique number
      void show_gl(const int& d, const float& deep);

};

#endif
