/********************************************************/
/* This class is used to create the dynamic boss rabbit */
/********************************************************/

/*
This file is part of Tuxworld.

    Tuxworld is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Tuxworld is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Tuxworld.  If not, see <http://www.gnu.org/licenses/>.

Ce fichier fait partie de Tuxworld.

	Tuxworld est un logiciel libre ; vous pouvez le redistribuer ou le
	modifier suivant les termes de la GNU General Public License telle
	que publiée par la Free Software Foundation ; soit la version 3 de
	la licence, soit (à votre gré) toute version ultérieure.

	Tuxworld est distribué dans l'espoir qu'il sera utile, mais SANS
	AUCUNE GARANTIE ; pas même la garantie implicite de
	COMMERCIABILISABILITÉ ni d'ADÉQUATION à UN OBJECTIF PARTICULIER.
	Consultez la GNU General Public License pour plus de détails.

	Vous devez avoir reçu une copie de la GNU General Public License
	en même temps que Tuxworld ; si ce n'est pas le cas,
	consultez <http://www.gnu.org/licenses>.
*/

#ifndef DYNAMIC_BOSS_RABBIT
#define DYNAMIC_BOSS_RABBIT

#define TIME_MAX 600

#include "dynamic_boss.h"
#include "vector2d.h"

class CDynamic_Boss_Rabbit : public CDynamic_Boss
{

   public :

   // constructor
   CDynamic_Boss_Rabbit(const SDyn_obj& dyn_obj_, const int& nbr_lifes_);

   // check new events in IA of boss rabbit
   void check(std::vector<std::shared_ptr<CDynamic_Fire> >& VFire_, const TVector2d<float>& p_tux);
   int status();

   private :
   
   int time_ticks, status_boss;

};

#endif
