#include "dynamic_object.h"

CDynamic_Object::CDynamic_Object(const SDyn_obj& dyn_obj_, const int& id_life_, const int& nbr_lifes_) :
                          dyn_obj(dyn_obj_), id_life(id_life_), isdeath(false), nbr_lifes(nbr_lifes_) {
}

TVector2d<float> CDynamic_Object::velocity_read() {
   return dyn_obj.v;
}

TVector2d<float> CDynamic_Object::position_read() {
   return dyn_obj.p;
}

void CDynamic_Object::accel(TVector2d<float> a) {
   dyn_obj.v += a;
}

void CDynamic_Object::stop() {
   dyn_obj.v.x = 0.0f;
   dyn_obj.v.y = 0.0f;
}

int CDynamic_Object::id_life_read() {
   return id_life;
}

bool CDynamic_Object::orientation_read() {
   return orientation;
}

void CDynamic_Object::orientation_eval() {

   if(orientation)
      orientation = false;
   else
      orientation = true;

}

bool CDynamic_Object::death_read() {
   return isdeath;
}

int CDynamic_Object::life_read() {
   return nbr_lifes;
}

void CDynamic_Object::life_eval() {
   --nbr_lifes;
}

void CDynamic_Object::death_eval() {
   isdeath = true;
}

void CDynamic_Object::killall() {
   isdeath = true;
   nbr_lifes = 0;
}
