/*************************************************/
/* This class is used to create the dynamic tama */
/*************************************************/

/*
This file is part of Tuxworld.

    Tuxworld is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Tuxworld is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Tuxworld.  If not, see <http://www.gnu.org/licenses/>.

Ce fichier fait partie de Tuxworld.

	Tuxworld est un logiciel libre ; vous pouvez le redistribuer ou le
	modifier suivant les termes de la GNU General Public License telle
	que publiée par la Free Software Foundation ; soit la version 3 de
	la licence, soit (à votre gré) toute version ultérieure.

	Tuxworld est distribué dans l'espoir qu'il sera utile, mais SANS
	AUCUNE GARANTIE ; pas même la garantie implicite de
	COMMERCIABILISABILITÉ ni d'ADÉQUATION à UN OBJECTIF PARTICULIER.
	Consultez la GNU General Public License pour plus de détails.

	Vous devez avoir reçu une copie de la GNU General Public License
	en même temps que Tuxworld ; si ce n'est pas le cas,
	consultez <http://www.gnu.org/licenses>.
*/

#ifndef DYNAMIC_TUX
#define DYNAMIC_TUX

#include "dynamic_object.h"

#define NBR_TICKS_INVINCIBLE 50

class CDynamic_Tux : public CDynamic_Object
{ 
   public :

      // constructor
      CDynamic_Tux(SDyn_obj dyn_obj_,
                    int id_life_, int tux_level_);

      // tux is injured ?
      bool injured();

      // init tux injure
      void init_injure();

      // check tux values
      void check();

      // Read the power to shut fires
      int power_read();

      // eval the power
      void power_eval(const bool& s);

      // the tux level 0 (mini), 1 (normal), 2 (super-tux)
      int level_read();

      // return speed tux depending on level
      float level_speed(); 

      void update_level(const bool& l);

      // is it runnung ?
      int run_read();

      // run or not with right or left direction
      void run_eval(const int& v);

      // is it jumping ?
      int jump_read();

      // eval if it jumping or not
      void jump_eval(const int& v);

      // the seep running
      int step_speed_read();

      // eval the new speed
      void step_speed_eval(const int& v);

      // how much money ?
      int nbr_coins_read();

      // update the money
      void nbr_coins_update();

      // restart from 0 money
      void reset_nbr_coins();

      // to eval fire event
      void fire_eval();

      // button fire was pressed ?
      bool fire_read();
   private :

      int ticks_invincible, tux_level, run, jump, step_speed, nbr_coins, power, ticks_power;
      bool fire;
};

#endif
