#include "graphic.h"


CGraphic::CGraphic(const SDL_Rect& coord_, const float& coef_resol_) : object_rect(coord_), coef_resol(coef_resol_), surface(NULL) {
}

CGraphic::CGraphic(SDL_Surface *p_surface, const SDL_Rect& p_object_rect, const float& coef_resol_) : surface(p_surface), coef_resol(coef_resol_) {

   // we get surface properties width, height, x, and y

   surface_rect.w = surface->w;
   surface_rect.h = surface->h;
   surface_rect.x = p_object_rect.x;
   surface_rect.y = p_object_rect.y;

   object_rect = surface_rect;

}

CGraphic::~CGraphic() {

}

SDL_Rect& CGraphic::surface_properties() {
   return surface_rect; 
}

SDL_Rect& CGraphic::object_properties() {
   return object_rect; 
}

void CGraphic::get_object_properties(SDL_Surface *surf_w_h) {

   object_rect.h = surf_w_h->h;
   object_rect.w = surf_w_h->w;

}

void CGraphic::get_object_properties(const SDL_Rect& obj_rect) {
   object_rect = obj_rect; 
}

void CGraphic::get_object_properties(const unsigned& w, const unsigned& h) {

   object_rect.h = h;
   object_rect.w = w;

}

void CGraphic::object_move(const int& x, const int& y) {

   object_rect.x = x;
   object_rect.y = y;

}

void CGraphic::show() {
}

bool CGraphic::eval(SDL_Event &ev) {

   return false;

}
