#include "joystick.h"

using namespace std;

CJoystick::CJoystick() : xvel(0), yvel(0), coef_joymotion(1.0f) {

   // init the joystick
   SDL_Init( SDL_INIT_JOYSTICK);

   // Init SDL joystick
   if (SDL_NumJoysticks() < 1 ) {
      cout << string("joystick.cpp : joystick is not present") << endl;
      return;
   }

   try {
      //Open the Joystick
      stick = SDL_JoystickOpen( 0 );

      if( stick == NULL )
         throw string("joystick.cpp : can't open the joystick");

   }
   catch(string caught) {
      cerr << caught << endl;
      throw;
   }

}

CJoystick::~CJoystick() {
   SDL_JoystickClose( stick );
}

void CJoystick::joymotion_eval(const SDL_Event& ev) {
   coef_joymotion = abs((ev.jaxis.value >> 10) / 32.0f);
}

float CJoystick::joymotion_read() {
   return coef_joymotion;
}

void CJoystick::joymotion_reset() {
   coef_joymotion = 1.0f;
}
