#include "tuxworld.h"
#include "level_game.h"
#include "init_gameworld.h"

using namespace std;

int main(int argc, char *argv[])
{

   s_game game;

   //to convert int <-> string
   CConverter conv;

   // window resolution
   game.coef_resol = 1.0f;

   // fullscreen is not enabled
   game.fullscreen = false;

   game.coef_resol = .0f;

   for(unsigned i = 1; i < argc; ++i) {

      if(argv[i][0] == 'f') {
         game.fullscreen = true;
         cout << "Fullscreen enabled" << endl;
         continue;
      }

      game.coef_resol = conv << string(argv[i]);
   }

   if(game.coef_resol < .1f || game.coef_resol > 1.0f) {
      cerr << "bad coef resolution" << endl;
      exit(0);
   }

   SDL_Event event;
   init_game_world(game);

   string str_level(IMG_PATH + "story/story1_");
   screen_wait(game, event, false, str_level, .01, 0);

   if(keys(game, event)) {
      cerr << "can't load keys config file" << endl;
      exit(0);
   }

   str_level.assign(IMG_PATH + "story/story2_");
   screen_wait(game, event, false, str_level, .01, 1);

   str_level.assign(IMG_PATH + "story/story3_");
   screen_wait(game, event, false, str_level, .01, 1);

   str_level.assign(IMG_PATH + "story/story4_");
   screen_wait(game, event, false, str_level, .01, 1);

   str_level.assign(IMG_PATH + "levels/level1_");
   screen_wait(game, event, false, str_level, .02, 0);

   str_level.assign(IMG_PATH + "loading/loading_");
   screen_wait(game, event, false, str_level, .02, 2);

   vector<string> files_ground;
   files_ground.push_back(string(IMG_PATH + "ground/ground-0-0.png"));
   files_ground.push_back(string(IMG_PATH + "ground/ground-0-1.png"));

   vector<string> files_seq_ennemy;
   files_seq_ennemy.push_back(string(IMG_PATH + "sequences/rabbits_seq_0.png"));
   files_seq_ennemy.push_back(string(IMG_PATH + "sequences/rabbits_seq_1.png"));

   level_game(game, NBR_APPEARANCES_RABBITS, 0, string(SOUNDS_PATH + "music0.wav"), string(IMG_PATH + "rabbit/rabbit_"), string(IMG_PATH + "sky/sky0.png"), files_ground, files_seq_ennemy, string(IMG_PATH + "boss1/boss1_"), string(IMG_PATH + "boss1/boss1_injured_"));
   del_datas(game);

   str_level.assign(IMG_PATH + "levels/level2_");
   screen_wait(game, event, false, str_level, .02, 0);

   str_level.assign(IMG_PATH + "loading/loading_");
   screen_wait(game, event, false, str_level, .02, 2);

   files_ground.clear();
   files_seq_ennemy.clear();

   files_ground.push_back(string(IMG_PATH + "ground/ground-1-0.png"));
   files_ground.push_back(string(IMG_PATH + "ground/ground-1-1.png"));

   files_seq_ennemy.push_back(string(IMG_PATH + "sequences/ladybugs_seq_0.png"));
   files_seq_ennemy.push_back(string(IMG_PATH + "sequences/ladybugs_seq_1.png"));

   level_game(game, NBR_APPEARANCES_RABBITS, 1, string(SOUNDS_PATH + "music1.wav"), string(IMG_PATH + "ladybug/ladybug_"), string(IMG_PATH + "sky/sky1.png"), files_ground, files_seq_ennemy, string(IMG_PATH + "boss2/boss2_"), string(IMG_PATH + "boss2/boss2_injured_"));
   del_datas(game);

   str_level.assign(IMG_PATH + "levels/level3_");
   screen_wait(game, event, false, str_level, .02, 1);

   str_level.assign(IMG_PATH + "loading/loading_");
   screen_wait(game, event, false, str_level, .02, 2);

   files_ground.clear();
   files_seq_ennemy.clear();

   files_ground.push_back(string(IMG_PATH + "ground/ground-2-0.png"));
   files_ground.push_back(string(IMG_PATH + "ground/ground-2-1.png"));

   files_seq_ennemy.push_back(string(IMG_PATH + "sequences/bumblebees_seq_0.png"));
   files_seq_ennemy.push_back(string(IMG_PATH + "sequences/bumblebees_seq_1.png"));

   level_game(game, NBR_APPEARANCES_RABBITS, 2, string(SOUNDS_PATH + "music2.wav"), string(IMG_PATH + "bumblebee/bumblebee_"), string(IMG_PATH + "sky/sky2.png"), files_ground, files_seq_ennemy, string(IMG_PATH + "boss3/bossbee_"), string(IMG_PATH + "boss3/bossbee_"));
   del_datas(game);

   str_level.assign(IMG_PATH + "story/story5_");
   screen_wait(game, event, false, str_level, .01, 1);

   str_level.assign(IMG_PATH + "story/story6_");
   screen_wait(game, event, false, str_level, .01, 1);

   return 0;
}
