/*************************************************************/
/* This class is used to work with a 2d vector math's vector */
/*************************************************************/

/*
This file is part of Tuxworld.

    Tuxworld is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Tuxworld is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Tuxworld.  If not, see <http://www.gnu.org/licenses/>.

Ce fichier fait partie de Tuxworld.

	Tuxworld est un logiciel libre ; vous pouvez le redistribuer ou le
	modifier suivant les termes de la GNU General Public License telle
	que publiée par la Free Software Foundation ; soit la version 3 de
	la licence, soit (à votre gré) toute version ultérieure.

	Tuxworld est distribué dans l'espoir qu'il sera utile, mais SANS
	AUCUNE GARANTIE ; pas même la garantie implicite de
	COMMERCIABILISABILITÉ ni d'ADÉQUATION à UN OBJECTIF PARTICULIER.
	Consultez la GNU General Public License pour plus de détails.

	Vous devez avoir reçu une copie de la GNU General Public License
	en même temps que Tuxworld ; si ce n'est pas le cas,
	consultez <http://www.gnu.org/licenses>.
*/

#ifndef VECTOR2D
#define VECTOR2D

#include <iostream>

template <typename T>
class TVector2d {

public :

   T x;
   T y;

   // constructor
   explicit TVector2d<T>(T const & x=T(), T const & y=T()) : x(x), y(y) { }

   TVector2d<T>& operator+= (TVector2d<T> v) {
      x += v.x,
      y += v.y;
      return *this;
   }


   TVector2d<T>& operator= (TVector2d<unsigned> const& v) {
      x = (float)v.x,
      y = (float)v.y;
      return *this;
   }

   TVector2d<T>& operator= (TVector2d<int> const& v) {
      x = (float)v.x,
      y = (float)v.y;
      return *this;
   }
};

template <class T>
TVector2d<T> operator+ (TVector2d<T> const& v1, TVector2d<T> const& v2) {
      
   return TVector2d<T>(v1.x + v2.x, v1.y + v2.y);

}

template <class T>
TVector2d<T> operator- (TVector2d<T> const& v1, TVector2d<T> const& v2) {
      
   return TVector2d<T>(v1.x - v2.x, v1.y - v2.y);

}

#endif
